import greenfoot.*;
import java.awt.Color;
import java.awt.Font;
import java.lang.Object;
import java.awt.FontMetrics;
import java.awt.Graphics;

public class Intro extends World
{
    private int cellsize;
    private float position;
    
    private int i;
    
    private int[] randposx = {5,6,7,8,9,10,5,6,7,8,9,10,7,8,9,10,7,8,9,10,9,10,0,1,9,10,0,1,0,1,2,3,0,1,2,3,0,1,2,3,4,5,0,1,2,3,4,5};
    private int[] randposy = {0,0,0,0,0,0,1,1,1,1,1,1,2,2,2,2,3,3,3,3,4,4,5,5,5,5,6,6,7,7,7,7,8,8,8,8,9,9,9,9,9,9,10,10,10,10,10,10};

    private int randvar;
    
    private GreenfootImage[] rectangle = new GreenfootImage[4];
    private GreenfootImage name;
    
    private boolean flow = true;
    private boolean random = false;
    
    private Graphics g = getBackground().getAwtImage().createGraphics();
    private FontMetrics fm;
    
    private int currentcolor = 255;
    private GreenfootImage blackscreen;
    private GreenfootImage logo = new GreenfootImage("logo.bmp");

    public Intro()
    {
        super(700,700,1);
        
        cellsize = 25;
        
        logo.scale(cellsize * 11, cellsize * 11);
        
        fm = g.getFontMetrics(new Font("MONOSPACED",Font.BOLD,cellsize * 2));
        
        name = new GreenfootImage(15 * cellsize,8 * cellsize);
        blackscreen = new GreenfootImage(getBackground().getWidth(),getBackground().getHeight());
        blackscreen.setColor(Color.black);
        blackscreen.fill();
        
        position = -getBackground().getWidth();

        for(i = 0;i < 4;i++)rectangle[i] = new GreenfootImage(cellsize*5,cellsize*5);
        
        i = 3;
        
        name.setFont(new Font("MONOSPACED",Font.BOLD,cellsize * 2));
        
        rectangle[0].setColor(new Color(155,0,0));
        rectangle[1].setColor(new Color(0,0,155));
        rectangle[2].setColor(new Color(0,155,0));
        rectangle[3].setColor(new Color(155,155,0));
    }
    
    public void act()
    {
        if(flow == true)FlowingRectangle();
        if(random == true)RandomRectangle();
        
        if(flow == false || random == true)
        {
            if(i < 70)
            {
                name.drawString("Pointifix",(name.getWidth()-fm.stringWidth("Pointifix"))/2,50);
                name.drawString("present",(name.getWidth()-fm.stringWidth("present"))/2,100);
                name.setTransparency(5);
                getBackground().drawImage(name,(getBackground().getWidth() - cellsize * 15)/2,(getBackground().getHeight() + cellsize * 12)/2);
            }
            else
            {
                if(i < 110)
                {
                    blackscreen.setTransparency((int)((i - 70) * 3.6));
                    getBackground().drawImage(blackscreen,0,0);
                }
                else
                {
                    blackscreen.setTransparency((int)((i - 110) * 3.6));
                    getBackground().drawImage(blackscreen,0,0);
                }
            }
            
            if(i == 150)
            {
                Greenfoot.setWorld(new Editor());
            }
            
            i++;
            
            if(i == 110)
            {
                blackscreen.setColor(Color.white);
                blackscreen.fill();
            }
        }
    }
    
    public void FlowingRectangle()
    {
        if(position == -getBackground().getWidth())
        {
            Greenfoot.playSound("worf.mp3");
        }
        
        if((((getBackground().getWidth() - cellsize * 11)/2) - position)/7 > 0.1)
        {
            rectangle[i].setColor(Color.white);
            rectangle[i].fill();
            getBackground().drawImage(rectangle[i],(int)position + (i * 2 * cellsize),((getBackground().getHeight() - cellsize * 11)/2) + (i * 2 * cellsize));
            position += (((getBackground().getWidth() - cellsize * 11)/2) - position)/7;
        }
        else
        {
            if(i == 0)
            {
                flow = false;
                random = true;
                Greenfoot.playSound("warp.mp3");
            }
            
            if(position != ((getBackground().getWidth() - cellsize * 11)/2))
            {
                rectangle[i].setColor(Color.white);
                rectangle[i].fill();
                getBackground().drawImage(rectangle[i],(int)position + (i * 2 * cellsize),((getBackground().getHeight() - cellsize * 11)/2) + (i * 2 * cellsize));
                position = ((getBackground().getWidth() - cellsize * 11)/2);
            }
            else
            {
                position = -getBackground().getWidth();
                i--;
            }
        }
        
        rectangle[0].setColor(new Color(155,0,0));
        rectangle[1].setColor(new Color(0,0,155));
        rectangle[2].setColor(new Color(0,155,0));
        rectangle[3].setColor(new Color(155,155,0));
        
        rectangle[i].fill();
        
        rectangle[i].setColor(Color.white);
        
        rectangle[i].fillRect(cellsize,cellsize,cellsize * 3,cellsize * 3);
        
        getBackground().drawImage(rectangle[i],(int)position + (i * 2 * cellsize),((getBackground().getHeight() - cellsize * 11)/2) + (i * 2 * cellsize));
    }
    
    public void RandomRectangle()
    {
        int randomvar = -1, colorx, colory;
        Color randomcolor = Color.white;
        boolean check = false;
        
        while(randposx[randvar] == -1)
        {
            randvar = Greenfoot.getRandomNumber(48);
        }
        
        colorx = ((getBackground().getWidth() - cellsize * 11)/2) + (randposx[randvar] * cellsize);
        colory = ((getBackground().getHeight() - cellsize * 11)/2) + (randposy[randvar] * cellsize);

        /*while (getBackground().getColorAt(colorx-cellsize, colory).equals(randomcolor) || getBackground().getColorAt(colorx+cellsize, colory).equals(randomcolor) || getBackground().getColorAt(colorx, colory-cellsize).equals(randomcolor) || getBackground().getColorAt(colorx, colory+cellsize).equals(randomcolor))
        {
            randomvar = 60 + Greenfoot.getRandomNumber(5) * 40;
            randomcolor = new Color(randomvar,randomvar,randomvar);
            if(getBackground().getColorAt(colorx-cellsize, colory).equals(Color.white) && getBackground().getColorAt(colorx+cellsize, colory).equals(Color.white) && getBackground().getColorAt(colorx, colory-cellsize).equals(Color.white) && getBackground().getColorAt(colorx, colory+cellsize).equals(Color.white))
            {
                break;
            }
        }*/
        
        randomcolor=logo.getColorAt(randposx[randvar]*cellsize,randposy[randvar]*cellsize);

        getBackground().setColor(randomcolor);
        getBackground().fillRect(((getBackground().getWidth() - cellsize * 11)/2) + (randposx[randvar] * cellsize),((getBackground().getHeight() - cellsize * 11)/2) + (randposy[randvar] * cellsize),cellsize,cellsize);
        
        randposx[randvar] = -1;
        
        for(i = 3; i >= 0; i--)
        {
            getBackground().drawImage(rectangle[i],(int)position + (i * 2 * cellsize),((getBackground().getHeight() - cellsize * 11)/2) + (i * 2 * cellsize));
        }
        
        for(i = 0; i< 48; i++)
        {
            if(randposx[i] != -1)check = true;
        }
        if(check == false)
        {
            random = false;
            i = 0;
        }
        
        Greenfoot.delay(1);
    }
}